VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "VBCursor"
   ClientHeight    =   3735
   ClientLeft      =   1800
   ClientTop       =   1560
   ClientWidth     =   4830
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3735
   ScaleWidth      =   4830
   Begin VB.Timer Timer1 
      Interval        =   1
      Left            =   480
      Top             =   1080
   End
   Begin VB.PictureBox Picture1 
      AutoSize        =   -1  'True
      Height          =   540
      Left            =   1440
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   480
      ScaleWidth      =   480
      TabIndex        =   10
      Top             =   960
      Width           =   540
   End
   Begin VB.CommandButton cmdGotoPicture 
      Caption         =   "&Goto Picture"
      Height          =   375
      Left            =   3360
      TabIndex        =   9
      Top             =   2280
      Width           =   1335
   End
   Begin VB.CommandButton cmdShowCursor 
      Caption         =   "&Show Cursor"
      Height          =   375
      Left            =   3360
      TabIndex        =   8
      Top             =   1800
      Width           =   1335
   End
   Begin VB.CommandButton cmdHideCursor 
      Caption         =   "&Hide Cursor"
      Height          =   375
      Left            =   3360
      TabIndex        =   7
      Top             =   1320
      Width           =   1335
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "&Exit"
      Height          =   375
      Left            =   3360
      TabIndex        =   5
      Top             =   3240
      Width           =   1335
   End
   Begin VB.CommandButton cmdClipCursor 
      Caption         =   "&Clip Cursor"
      Height          =   375
      Left            =   3360
      TabIndex        =   1
      Top             =   840
      Width           =   1335
   End
   Begin VB.Frame famClipArea 
      Caption         =   "Clip Area"
      Height          =   1935
      Left            =   120
      TabIndex        =   0
      Top             =   1680
      Width           =   3015
      Begin VB.CommandButton cmdUnclipCursor 
         Caption         =   "&Unclip Cursor"
         Height          =   375
         Left            =   600
         TabIndex        =   2
         Top             =   1320
         Width           =   1815
      End
      Begin VB.Label Label3 
         Alignment       =   2  'Center
         Caption         =   "Mouse Cursor Position"
         Height          =   255
         Left            =   600
         TabIndex        =   6
         Top             =   360
         Width           =   1815
      End
      Begin VB.Label lblCursorPosition 
         Alignment       =   2  'Center
         BackStyle       =   0  'Transparent
         BorderStyle     =   1  'Fixed Single
         Caption         =   "Label2"
         Height          =   375
         Left            =   720
         TabIndex        =   4
         Top             =   720
         Width           =   1575
      End
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "How to control mouse cursor with Win API"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   222
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   0
      TabIndex        =   3
      Top             =   120
      Width           =   4815
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type POINTAPI
        X As Long
        Y As Long
End Type

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Declare Function ClipCursor& Lib "user32" (lpRect As Any)
Private Declare Function ResetClipCursor& Lib "user32" Alias "ClipCursor" (ByVal R&)
Private Declare Function GetWindowRect& Lib "user32" (ByVal hwnd&, lpRect As RECT)
Private Declare Function ShowCursor& Lib "user32" (ByVal bShow&)
Private Declare Function SetCursorPos& Lib "user32" (ByVal X&, ByVal Y&)
Private Declare Function GetCursorPos& Lib "user32" (lpPoint As POINTAPI)

Private Sub cmdClipCursor_Click()
    Dim R As RECT
    
    Call GetWindowRect(famClipArea.hwnd, R)
    Call ClipCursor(R)
End Sub

Private Sub cmdUnclipCursor_Click()
    Call ResetClipCursor(0)
End Sub

Private Sub cmdExit_Click()
    cmdUnclipCursor_Click
    cmdShowCursor_Click
    End
End Sub

Private Sub cmdGotoPicture_Click()
    Dim R As RECT
    
    Call GetWindowRect(Picture1.hwnd, R)
    Call SetCursorPos(R.Left, R.Top)
End Sub

Private Sub cmdHideCursor_Click()
    Do While ShowCursor(False) >= -1
    Loop
    Do While ShowCursor(True) < -1
    Loop
End Sub

Private Sub cmdShowCursor_Click()
    Do While ShowCursor(False) >= 0
    Loop
    Do While ShowCursor(True) < 0
    Loop
End Sub

Private Sub Timer1_Timer()
    Dim P As POINTAPI, S As String
    
    Call GetCursorPos(P)
    S = Str$(P.X) & "," & Str$(P.Y)
    lblCursorPosition.Caption = S
End Sub
